#!/bin/sh
#
#  this is a sanity check of utf-8 handling that uses Python's utf-8 
#    codec as a reference point
#

set -e
set -x

test_files="`find data/utf-8 -type f`"

function test_utf_8 {
  pyopt="$1"

  for x in $test_files
  do
    echo $x
    xbase="test-tmp/`basename $x`"
    # do python and cxx decode the same?
    ./decode <$x >${xbase}-decoded
    ./pydecode.py ${pyopt} <$x >${xbase}-pydecoded
    cmp ${xbase}-decoded ${xbase}-pydecoded

    # are the four possible round-trips through python and cxx idempotent?
    ./pyencode.py ${pyopt} <${xbase}-decoded >${xbase}-decoded-pyencoded
    cmp ${x} ${xbase}-decoded-pyencoded
    ./encode <${xbase}-decoded >${xbase}-decoded-encoded
    cmp ${x} ${xbase}-decoded-encoded
    ./encode <${xbase}-pydecoded >${xbase}-pydecoded-encoded
    cmp ${x} ${xbase}-pydecoded-encoded
    ./pyencode.py ${pyopt} <${xbase}-pydecoded >${xbase}-pydecoded-pyencoded
    cmp ${x} ${xbase}-pydecoded-pyencoded
  done
}

# test using python's built in utf-8 codec
test_utf_8
# test using our utf-8b python codec
test_utf_8 -b

echo
echo all passed
